package org.dynmap.factions;

import org.bukkit.configuration.file.FileConfiguration;
import org.dynmap.markers.MarkerIcon;

class AreaStyle {

    final String strokecolor;
    final double strokeopacity;
    final int strokeweight;
    final String fillcolor;
    final double fillopacity;
    final String homemarker;
    MarkerIcon homeicon;
    final boolean boost;

    AreaStyle(DynmapFactionsPlugin dynmapFactionsPlugin, FileConfiguration cfg, String path, AreaStyle def) {
        strokecolor = cfg.getString(path + ".strokeColor", def.strokecolor);
        strokeopacity = cfg.getDouble(path + ".strokeOpacity", def.strokeopacity);
        strokeweight = cfg.getInt(path + ".strokeWeight", def.strokeweight);
        fillcolor = cfg.getString(path + ".fillColor", def.fillcolor);
        fillopacity = cfg.getDouble(path + ".fillOpacity", def.fillopacity);
        homemarker = cfg.getString(path + ".homeicon", def.homemarker);
        if (homemarker != null) {
            homeicon = dynmapFactionsPlugin.markerapi.getMarkerIcon(homemarker);
            if (homeicon == null) {
                DynmapFactionsPlugin.severe("Invalid homeicon: " + homemarker);
                homeicon = dynmapFactionsPlugin.markerapi.getMarkerIcon("blueicon");
            }
        }
        boost = cfg.getBoolean(path + ".boost", def.boost);
    }

    AreaStyle(DynmapFactionsPlugin dynmapFactionsPlugin, FileConfiguration cfg, String path) {
        strokecolor = cfg.getString(path + ".strokeColor", "#FF0000");
        strokeopacity = cfg.getDouble(path + ".strokeOpacity", 0.8);
        strokeweight = cfg.getInt(path + ".strokeWeight", 3);
        fillcolor = cfg.getString(path + ".fillColor", "#FF0000");
        fillopacity = cfg.getDouble(path + ".fillOpacity", 0.35);
        homemarker = cfg.getString(path + ".homeicon", null);
        if (homemarker != null) {
            homeicon = dynmapFactionsPlugin.markerapi.getMarkerIcon(homemarker);
            if (homeicon == null) {
                DynmapFactionsPlugin.severe("Invalid homeicon: " + homemarker);
                homeicon = dynmapFactionsPlugin.markerapi.getMarkerIcon("blueicon");
            }
        }
        boost = cfg.getBoolean(path + ".boost", false);
    }
    
}
